<?php
include_once("application/config.php");//配置信息
include_once("application/common.php");//公共方法
include_once("extend/mysql/Connection.php");//mysql方法

class socketWork {
	
	public $server;
	
	public function __construct($server) {
		$this->server = $server;
		//链接数据库
		$GLOBALS['redisDB'] = cache($GLOBALS['config']['REDIS']);
		$GLOBALS['mysqlDB'] = new \Workerman\MySQL\Connection($GLOBALS['config']['MYSQL']['DB_HOST'], $GLOBALS['config']['MYSQL']['DB_PORT'], $GLOBALS['config']['MYSQL']['DB_USER'], $GLOBALS['config']['MYSQL']['DB_PWD'], $GLOBALS['config']['MYSQL']['DB_NAME']);
	}  
	
	public function onWorkerStop( $server , $worker_id) {
		if ($GLOBALS['redisDB']) {
			$GLOBALS['redisDB']->close();
		}
		if ($GLOBALS['mysqlDB']) {
			$GLOBALS['mysqlDB']->closeConnection();
		}
    }   

	public function onWorkerError( $server , $worker_id) {
		echo _log('work进程报错');
    }

	public function onOpen($server, $frame) {

		$uid = 'fd'.$frame->fd;
		$GLOBALS['USER_LIST']->set($uid,array('fd'=>$frame->fd));
		$server->push($frame->fd, "你好：$uid");
		
	}

	public function onMessage($server, $frame) {
		$data = json_decode($frame->data,true);
		
		// $path = 'application/socket/'.$data['m'].'.php';
		if (class_exists($data['m'])) {

			$data['fd']     = $frame->fd;
			$data['ip']     = $this->server->connections[$frame->fd]['remote_ip'];
			
			$tmp_task_id = $this->server->task($data);
            echo_log("进行task任务:".$tmp_task_id);
		}else{
			$server->push($frame->fd, "找不到对应的模块");
		}
	}

	public function onRequest($server, $request, $response) {
		$event = $request->get['event'];
		if($event == 'reload') {
			$server->reload();
			$response->write('reload success');
		}else if($event == 'sendAll') {
			$this->sendAll($server,'大家好');
			$response->write($GLOBALS['USER_LIST']->get('fd3'));
		} else {
			// $data = $this->server->db->select('sysid as id,name')->from('yl_goods')->where('sysid=1')->row();
			// $reData = json_encode(array('c'=>1,'msg'=>'success','d'=>array('list'=>$data)));
			$response->write('websocket server respone');
		}
	}
	
	public function onTask($server, $task_Id, $worker_id, $data) {
		echo_log("进行task任务:".$task_Id.'开始工作');

		$act = new $data['m']();
		//是否有这个方法在
		if (!method_exists($act, $data['a'])) {
			$server->push($frame->fd, "找不到对应的方法");
			$this->server->finish($task_Id);
            return false;
		} else {
			$data['server'] = $server;
			if($act->setData($data)){
				echo_log("执行情况：".$act->{$data['a']}() );
				$this->server->finish($task_Id);
				return true;
			}else{
				echo_log("执行出错：".$data['m']."->".$data['a']."\r\n");
				$this->server->finish($task_Id);
				return false;
			}
		}

	}
	
	public function onFinish($server,$task_Id, $data) {
		echo_log("进行task任务:".$task_Id.'工作完成');
	}
	
	public function onClose($server, $fd) {
		$GLOBALS['USER_LIST']->del('fd'.$fd);
		echo 'client'.$fd.'下线';
		//$this->redis->hdel($this->userTable,"fd{$fd}");
		//$this->sendAll($server,"用户{$fd}下线了");
	}
	

	//根据用户ID查用户的连接记录
	public function get_user_by_uid($uid){
		echo_log(__CLASS__."->".__FUNCTION__."\r\n");
		if($GLOBALS['USER_LIST']->exist($uid)){
			$tmp_val = $GLOBALS['USER_LIST']->get($uid);
			return $tmp_val;
		}else{
			return false;
		}
	}
	//根据用户的fd查用户的uid
	public function get_user_by_fd($fd){
		echo_log(__CLASS__."->".__FUNCTION__."\r\n");
		if($GLOBALS['USER_LIST_FD']->exist($fd)){
			$tmp_val = $GLOBALS['USER_LIST_FD']->get($fd);
			return $tmp_val;
		}else{
			return false;
		}
	}

	//设置用户在线
	/*
	$data = array(
		"fd"		=> ,//"连接",
		"uid"		=> ,//用户ID,
	);
	*/
	public function set_user_list($data){
		//删掉这个uid之前绑定的连接
		$tmp_uid = $GLOBALS['USER_LIST']->get($data['uid']);
		if($tmp_uid && $tmp_uid['fd']>0){
			$GLOBALS['USER_LIST_FD']->del($tmp_uid['fd']);
			$GLOBALS['USER_LIST']->del($data['uid']);
		}
		$GLOBALS['USER_LIST']->set($data['uid'],array('fd'=>$data['fd']));
		$GLOBALS['USER_LIST_FD']->set($data['fd'],array('uid'=>$data['uid']));
		return true;
	}

	//给某个用户发信息
	public function send_user($fd,$data,$opcode=1,$finish=true){
		echo_log(__CLASS__."->".__FUNCTION__."\r\n");
		if(empty($fd)){
			return false;
		}

		if(is_array($data)){
			$data = return_ajax($data);
			echo $data;
		}
		//检测通道是否存在
		if(!$this->server->exist($fd)){
			echo_log("通道[ $fd ]的客户端已经断开,无法发送消息!\r\n",$data);
			unset($data);
			return false;
		}else{
			$this->server->push($fd,$data,$opcode,$finish);
			unset($data);
			return $finish;
		}
	}

	//给指定用户发信息
	public function send_all($arr,$data,$opcode=1,$finish=true){
		echo_log(__CLASS__."->".__FUNCTION__."\r\n");
		if(!empty($arr)){
			foreach($arr as $uid){
				if($GLOBALS['USER_LIST']->exist($uid)){
					$tmp_fd = $GLOBALS['USER_LIST']->get($uid);
					if($this->send_user($tmp_fd['fd'],$data,$opcode,$finish)){
						echo_log('用户['. $uid .']发送消息成功!\r\n');
					}else{
						echo_log('用户['. $uid .']的客户端已经断开,无法发送消息!\r\n');
					}
				}
			}
		}else{
			echo_log('没有指定要发信息的用户,无法发送消息!\r\n');
		}
		return true;
	}

}